/*****************************************************************************
 * Copyright (C) 2005, 2006 Imre Kelnyi, Bertalan Forstner
 *-------------------------------------------------------------------
 * This file is part of Symella
 *
 * Symella is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Symella is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Symella; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *****************************************************************************/

#ifndef SALOGGER_H
#define SALOGGER_H

// uncomment the next line if you want to have 
// the log saved into a file (symella.log)
#ifdef __WINS__
	#define LOG_TO_FILE
#endif

#include <coemain.h>

const TUid KUidSymellaLogger = { 0x10000EF1 };

#define LOG CSALogger::InstanceL()

/**
 * Observer class for handling events generated by CSALogger
 */
class MLogObserver
{
public:

	/**
	 * Called when text is added to the log.
	 */
	virtual void HandleLogWriteL(const TDesC& aText) = 0;
};


class CSALogger : public CCoeStatic
{
public:

	static CSALogger* InstanceL();

	~CSALogger();

	void ConstructL();

	void SetObserver(MLogObserver* aObserver);

	void WriteL(const TDesC& aText);

	void WriteL(const TDesC8& aText);

	void WriteLineL(const TDesC& aText);

	void WriteLineL(const TDesC8& aText);

	void WriteLineL();

	void WriteL(TInt aInt);

	void WriteLineL(TInt aInt);


protected:

	CSALogger() : CCoeStatic(KUidSymellaLogger) {}

private:

	RFs iFsSession;

	RFile iLogFile;

	MLogObserver* iObserver;
};


inline void CSALogger::SetObserver(MLogObserver* aObserver) {
	iObserver = aObserver;
}



#endif
